//+------------------------------------------------------------------+
//|           FPI  Fractional Product Inefficiency                  |
//|                                                          FPI.mq4 |
//|                                         Developed by Coders Guru |
//|                                            http://www.xpworx.com |
//+------------------------------------------------------------------+

#property link      "http://www.xpworx.com"
#property copyright "Coders' Guru" 


#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Yellow


double Main[] , EURUSD[] ,USDNOK[] ,USDJPY[] ,GBPUSD[] ,USDCAD[] ,USDCHF[] ;

int init()
  {
   IndicatorBuffers(8); 
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Main);
   
   SetIndexBuffer(1,EURUSD);
   SetIndexBuffer(2,USDNOK);
   SetIndexBuffer(3,USDJPY);
   SetIndexBuffer(4,GBPUSD);
   SetIndexBuffer(5,USDCAD);
   SetIndexBuffer(6,USDCHF);

   ArrayInitialize(EURUSD,EMPTY_VALUE);
   ArrayInitialize(USDNOK,EMPTY_VALUE);
   ArrayInitialize(USDJPY,EMPTY_VALUE);
   ArrayInitialize(GBPUSD,EMPTY_VALUE);
   ArrayInitialize(USDCAD,EMPTY_VALUE);
   ArrayInitialize(USDCHF,EMPTY_VALUE);
   ArrayInitialize(Main,EMPTY_VALUE);

   return(0);
  }

int deinit()
  {
   return(0);
  }

int start()
  {

   ArrayCopySeries(EURUSD,MODE_CLOSE,"EURUSD",Period());
   ArrayCopySeries(USDNOK,MODE_CLOSE,"USDNOK",Period());
   ArrayCopySeries(USDJPY,MODE_CLOSE,"USDJPY",Period());
   ArrayCopySeries(GBPUSD,MODE_CLOSE,"GBPUSD",Period());
   ArrayCopySeries(USDCAD,MODE_CLOSE,"USDCAD",Period());
   ArrayCopySeries(USDCHF,MODE_CLOSE,"USDCHF",Period());

   int counted_bars=IndicatorCounted();
   int i = 0;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   
   for(i=0; i<limit; i++)
   {
       Main[i] = 50.14348112 * MathPow(EURUSD[i],-0.576) * MathPow(USDJPY[i],0.136) * MathPow(GBPUSD[i],-0.119) * MathPow(USDCAD[i],0.091) * MathPow(USDNOK[i],0.042) * MathPow(USDCHF[i],0.036);
 
       
   }

   return(0);
}  
//+------------------------------------------------------------------+