//+------------------------------------------------------------------+
//|                                                       Thirds.mq4 |
//|                                                      Magnumfreak |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Magnumfreak"
#property link      ""

#property indicator_chart_window
int count =1;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
      ObjectCreate("onesixth",1,0,TimeCurrent(),High[120]);
      ObjectSet("onesixth",OBJPROP_COLOR,Gold);
      ObjectSet("onesixth",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("onesixth",OBJPROP_WIDTH,1);     
  
      ObjectCreate("twosixth",1,0,TimeCurrent(),High[120]);
      ObjectSet("twosixth",OBJPROP_COLOR,Green);
      ObjectSet("twosixth",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("twosixth",OBJPROP_WIDTH,1);    

      ObjectCreate("threesixth",1,0,TimeCurrent(),High[120]);
      ObjectSet("threesixth",OBJPROP_COLOR,Black);
      ObjectSet("threesixth",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("threesixth",OBJPROP_WIDTH,1);
      
      ObjectCreate("foursixth",1,0,TimeCurrent(),Low[120]);
      ObjectSet("foursixth",OBJPROP_COLOR,Green);
      ObjectSet("foursixth",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("foursixth",OBJPROP_WIDTH,1);
      
      ObjectCreate("fivesixth",1,0,TimeCurrent(),Low[120]);
      ObjectSet("fivesixth",OBJPROP_COLOR,Gold);
      ObjectSet("fivesixth",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("fivesixth",OBJPROP_WIDTH,1);
      

      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
   
//----
//----
   double value = WindowPriceMax(0)-WindowPriceMin(0);      //value top of the chart - value buttem
   double sixth = value/6;
   double valueS = (value*(MathPow(10,Digits)));
   double sixthS = (sixth*(MathPow(10,Digits)));
   
   double seventh = value/7;
   //double valueS = (value*(MathPow(10,Digits)));
   double seventhS = (seventh*(MathPow(10,Digits)));
   
   if(ObjectFind("fivesixth")==-1)init();
   //Comment(ObjectFind("sixth"));
   ObjectMove("onesixth",0,TimeCurrent(),WindowPriceMin(0)+sixth);
   ObjectMove("twosixth",0,TimeCurrent(),WindowPriceMin(0)+sixth+sixth);
   ObjectMove("threesixth",0,TimeCurrent(),WindowPriceMin(0)+sixth+sixth+sixth);
   ObjectMove("foursixth",0,TimeCurrent(),WindowPriceMin(0)+sixth+sixth+sixth+sixth);
   ObjectMove("fivesixth",0,TimeCurrent(),WindowPriceMin(0)+sixth+sixth+sixth+sixth+sixth);

   Comment("Top to bottem = ", (valueS), " pips", "\n" ,"Distance between lines = ", (sixthS), " pips" , 
           "\n" ,"TAKE PROFIT DISTANCE = ", (seventhS), " pips");
      
//----
   return(0);
  }
//+------------------------------------------------------------------+