//+------------------------------------------------------------------+
//|                                                   LSMA trend.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property  copyright "mladen"
#property  link      ""

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Red
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1

//
//
//
//
//

extern int LSMAPeriod   = 35;
extern int LSMAPrice    =  0;

//
//
//
//
//

double trendOa[];
double trendDa[];
double trendDb[];
double trend[];
double lsma[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,trendOa);
   SetIndexBuffer(1,trendDa);
   SetIndexBuffer(2,trendDb);
   SetIndexBuffer(3,trend);
   SetIndexBuffer(4,lsma);
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{ 
   int counted_bars=IndicatorCounted();
   int limit,i;


   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   if (trend[limit]==-1) CleanPoint(limit,trendDa,trendDb);
      for(i = limit; i >= 0; i--)
      {
         lsma[i] = 3.0*iMA(NULL,0,LSMAPeriod,0,MODE_LWMA,LSMAPrice,i)-2.0*iMA(NULL,0,LSMAPeriod,0,MODE_SMA,LSMAPrice,i);
         if (i==Bars-1) { trendOa[i] = 0; continue; }
                  trend[i]   = trend[i+1];
                  trendOa[i] = trendOa[i+1];
                  trendDa[i] = EMPTY_VALUE;
                  trendDb[i] = EMPTY_VALUE;
         if (lsma[i]>lsma[i+1]) trend[i] =  1;
         if (lsma[i]<lsma[i+1]) trend[i] = -1;
         if (trend[i] ==  1) { trendOa[i] += 0.01; }
         if (trend[i] == -1) { trendOa[i] -= 0.01; PlotPoint(i,trendDa,trendDb,trendOa); }
      }   
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}